
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module FLIR_LAPTON(

	//////////// CLOCK //////////
	input 		          		ADC_CLK_10,
	input 		          		MAX10_CLK1_50,
	input 		          		MAX10_CLK2_50,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [15:0]		DRAM_DQ,
	output		          		DRAM_LDQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_UDQM,
	output		          		DRAM_WE_N,

	//////////// SEG7 //////////
	output		     [7:0]		HEX0,
	output		     [7:0]		HEX1,
	output		     [7:0]		HEX2,
	output		     [7:0]		HEX3,
	output		     [7:0]		HEX4,
	output		     [7:0]		HEX5,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [9:0]		LEDR,

	//////////// SW //////////
	input 		     [9:0]		SW,

	//////////// VGA //////////
	output		     [3:0]		VGA_B,
	output		     [3:0]		VGA_G,
	output		          		VGA_HS,
	output		     [3:0]		VGA_R,
	output		          		VGA_VS,

	//////////// Accelerometer //////////
	output		          		GSENSOR_CS_N,
	input 		     [2:1]		GSENSOR_INT,
	output		          		GSENSOR_SCLK,
	inout 		          		GSENSOR_SDI,
	inout 		          		GSENSOR_SDO,

	//////////// Arduino //////////
	inout 		    [15:0]		ARDUINO_IO,
	inout 		          		ARDUINO_RESET_N,

	//////////// GPIO, GPIO connect to LT24 - 2.4" LCD and Touch //////////
	input 		          		LT24_ADC_BUSY,
	output		          		LT24_ADC_CS_N,
	output		          		LT24_ADC_DCLK,
	output		          		LT24_ADC_DIN,
	input 		          		LT24_ADC_DOUT,
	input 		          		LT24_ADC_PENIRQ_N,
	output		          		LT24_CS_N,
	output		    [15:0]		LT24_D,
	output		          		LT24_LCD_ON,
	output		          		LT24_RD_N,
	output		          		LT24_RESET_N,
	output		          		LT24_RS,
	output		          		LT24_WR_N
);



//=======================================================
//  REG/WIRE declarations
//=======================================================

wire reset_n;
wire spi_clk;

//=======================================================
//  Structural coding
//=======================================================


assign reset_n = KEY[0];

//sys_pll sys_pll_inst(
//		.refclk(FPGA_CLK1_50),   //  refclk.clk
//		.rst(1'b0),      //   reset.reset
//		.outclk_0(spi_clk), // outclk0.clk
//		.locked(pll_locked)    //  locked.export
//	);


assign LT24_LCD_ON = 1'b1; 
	
wire lapton_reset_n;
LAPTON LAPTON_inst(
	.reset_n(reset_n),
	.clk(spi_clk),
	
	// memory
	// memory 
	.mem_data(data),
	.mem_addr(wraddress),
	.mem_write(wren),
	.mem_clk(wrclock),	
	
	// camera module
	.I2C_SCL(ARDUINO_IO[15]),
	.I2C_SDA(ARDUINO_IO[14]),
	.SPI_CS_n(ARDUINO_IO[10]),
	.SPI_MOSI(ARDUINO_IO[11]),
	.SPI_MISO(ARDUINO_IO[12]),
	.SPI_CLK(ARDUINO_IO[13])
);

	wire	[15:0]  data;
	wire	[12:0]  rdaddress;
	wire	  rdclock;
	wire	[12:0]  wraddress;
	wire	  wrclock;
	wire	  wren;
	wire	[15:0]  q;	
 
 
 vram vram_inst(
	.data(data),
	.rdaddress(rdaddress),
	.rdclock(rdclock),
	.wraddress(wraddress),
	.wrclock(wrclock),
	.wren(wren),
	.q(q));




    Video_Qsys u0 (
        .clk_clk                                      (MAX10_CLK1_50),                                      //                            clk.clk
        .reset_reset_n                                (reset_n),                                //                          reset.reset_n
        .clk_vga_clk                                  (disp_clk),                                  //                        clk_vga.clk
        .clk_spi_clk                                  (spi_clk),                                   //                              clk_spi.clk
		  
        .led_external_connection_export                   (LEDR),                   //                   led_external_connection.export
        .switch_external_connection_export                (SW),                 //                switch_external_connection.export

		  
		  // VGA output
        .alt_vip_cl_cvo_0_clocked_video_vid_clk       (disp_clk),       // alt_vip_cl_cvo_0_clocked_video.vid_clk
        .alt_vip_cl_cvo_0_clocked_video_vid_data      (disp_data),      //                               .vid_data
        .alt_vip_cl_cvo_0_clocked_video_underflow     (),     //                               .underflow
        .alt_vip_cl_cvo_0_clocked_video_vid_datavalid (), //                               .vid_datavalid
        .alt_vip_cl_cvo_0_clocked_video_vid_v_sync    (disp_vs),    //                               .vid_v_sync
        .alt_vip_cl_cvo_0_clocked_video_vid_h_sync    (disp_hs),    //                               .vid_h_sync
        .alt_vip_cl_cvo_0_clocked_video_vid_f         (),         //                               .vid_f
        .alt_vip_cl_cvo_0_clocked_video_vid_h         (),         //                               .vid_h
        .alt_vip_cl_cvo_0_clocked_video_vid_v         (),          //                               .vid_v
		  
		  //
		//SDRAM
		.clk_sdram_clk(DRAM_CLK),                  //               clk_sdram.clk
	   .sdram_wire_addr(DRAM_ADDR),                //              sdram_wire.addr
		.sdram_wire_ba(DRAM_BA),                  //                        .ba
		.sdram_wire_cas_n(DRAM_CAS_N),               //                        .cas_n
		.sdram_wire_cke(DRAM_CKE),                 //                        .cke
		.sdram_wire_cs_n(DRAM_CS_N),                //                        .cs_n
		.sdram_wire_dq(DRAM_DQ),                  //                        .dq
		.sdram_wire_dqm({DRAM_UDQM,DRAM_LDQM}),                 //                        .dqm
		.sdram_wire_ras_n(DRAM_RAS_N),               //                        .ras_n
		.sdram_wire_we_n(DRAM_WE_N),                 //                        .we_n		  
		  
		  
		// LT24, lcd  
	  .lcd_cs_n_export    (LT24_CS_N),    //    lcd_cd_n.export
	  .lcd_rs_export      (LT24_RS),      //      lcd_rs.export  LCD data/command change
	  .lcd_wr_n_export    (LT24_WR_N),    //    lcd_wr_n.export
	  .lcd_rd_n_export    (LT24_RD_N),    //    lcd_rd_n.export
	  .lcd_reset_n_export (LT24_RESET_N), // lcd_reset_n.export
	  .lcd_data_export    (LT24_D),     //    lcd_data.export
	  
        // LT24, touch
	     .touch_panel_pen_irq_n_external_connection_export                   (LT24_ADC_PENIRQ_N),                   // touch_panel_pen_irq_n_external_connection.export
        .touch_panel_busy_external_connection_export                        (LT24_ADC_BUSY),                        //      touch_panel_busy_external_connection.export
        .touch_panel_spi_external_MISO                                      (LT24_ADC_DOUT),                                      //                  touch_panel_spi_external.MISO
        .touch_panel_spi_external_MOSI                                      (LT24_ADC_DIN),                                      //                                          .MOSI
        .touch_panel_spi_external_SCLK                                      (LT24_ADC_DCLK),                                      //                                          .SCLK
        .touch_panel_spi_external_SS_n                                      (LT24_ADC_CS_N),                                      //                                          .SS_n
		  
		  // Lapton reader
        .lapton_conduit_end_mem_read_data                 (q),                 //                                          .mem_read_data
        .lapton_conduit_end_mem_read_addr                 (rdaddress),                 //                        lapton_conduit_end.mem_read_addr
        .lapton_conduit_end_mem_read_clk                  (rdclock),                  //                                          .mem_read_clk
        .lapton_conduit_end_i2c_scl                       (),                       //                                          .i2c_scl
        .lapton_conduit_end_i2c_sda                       (),                       //                                          .i2c_sda
        .lapton_conduit_end_spi_cs_n                      (),                      //                                          .spi_cs_n
        .lapton_conduit_end_spi_mosi                      (),                      //                                          .spi_mosi
        .lapton_conduit_end_spi_miso                      (),                      //                                          .spi_miso
        .lapton_conduit_end_spi_clk                       (),                       //                                          .spi_clk
		  
        .lapton_reset_n_external_connection_export        (lapton_reset_n)         //        lapton_reset_n_external_connection.export
		  
		  
		  
		  
    );
	 
wire 			disp_clk;	 
wire 			disp_hs;
wire 			disp_vs;
wire [23:0]	disp_data;

assign VGA_HS = disp_hs;
assign VGA_VS = disp_vs;
assign VGA_B = disp_data[7:4];
assign VGA_G = disp_data[15:12];
assign VGA_R = disp_data[23:20];


endmodule
