	component Video_Qsys is
		port (
			alt_vip_cl_cvo_0_clocked_video_vid_clk           : in    std_logic                     := 'X';             -- vid_clk
			alt_vip_cl_cvo_0_clocked_video_vid_data          : out   std_logic_vector(23 downto 0);                    -- vid_data
			alt_vip_cl_cvo_0_clocked_video_underflow         : out   std_logic;                                        -- underflow
			alt_vip_cl_cvo_0_clocked_video_vid_datavalid     : out   std_logic;                                        -- vid_datavalid
			alt_vip_cl_cvo_0_clocked_video_vid_v_sync        : out   std_logic;                                        -- vid_v_sync
			alt_vip_cl_cvo_0_clocked_video_vid_h_sync        : out   std_logic;                                        -- vid_h_sync
			alt_vip_cl_cvo_0_clocked_video_vid_f             : out   std_logic;                                        -- vid_f
			alt_vip_cl_cvo_0_clocked_video_vid_h             : out   std_logic;                                        -- vid_h
			alt_vip_cl_cvo_0_clocked_video_vid_v             : out   std_logic;                                        -- vid_v
			clk_clk                                          : in    std_logic                     := 'X';             -- clk
			clk_sdram_clk                                    : out   std_logic;                                        -- clk
			clk_spi_clk                                      : out   std_logic;                                        -- clk
			clk_vga_clk                                      : out   std_logic;                                        -- clk
			lapton_conduit_end_mem_read_addr                 : out   std_logic_vector(12 downto 0);                    -- mem_read_addr
			lapton_conduit_end_mem_read_clk                  : out   std_logic;                                        -- mem_read_clk
			lapton_conduit_end_i2c_scl                       : inout std_logic                     := 'X';             -- i2c_scl
			lapton_conduit_end_i2c_sda                       : inout std_logic                     := 'X';             -- i2c_sda
			lapton_conduit_end_spi_cs_n                      : out   std_logic;                                        -- spi_cs_n
			lapton_conduit_end_spi_mosi                      : out   std_logic;                                        -- spi_mosi
			lapton_conduit_end_spi_miso                      : in    std_logic                     := 'X';             -- spi_miso
			lapton_conduit_end_spi_clk                       : out   std_logic;                                        -- spi_clk
			lapton_conduit_end_mem_read_data                 : in    std_logic_vector(15 downto 0) := (others => 'X'); -- mem_read_data
			lapton_reset_n_external_connection_export        : out   std_logic;                                        -- export
			lcd_cs_n_export                                  : out   std_logic;                                        -- export
			lcd_data_export                                  : inout std_logic_vector(15 downto 0) := (others => 'X'); -- export
			lcd_rd_n_export                                  : out   std_logic;                                        -- export
			lcd_reset_n_export                               : out   std_logic;                                        -- export
			lcd_rs_export                                    : out   std_logic;                                        -- export
			lcd_wr_n_export                                  : out   std_logic;                                        -- export
			led_external_connection_export                   : out   std_logic_vector(9 downto 0);                     -- export
			reset_reset_n                                    : in    std_logic                     := 'X';             -- reset_n
			sdram_wire_addr                                  : out   std_logic_vector(12 downto 0);                    -- addr
			sdram_wire_ba                                    : out   std_logic_vector(1 downto 0);                     -- ba
			sdram_wire_cas_n                                 : out   std_logic;                                        -- cas_n
			sdram_wire_cke                                   : out   std_logic;                                        -- cke
			sdram_wire_cs_n                                  : out   std_logic;                                        -- cs_n
			sdram_wire_dq                                    : inout std_logic_vector(15 downto 0) := (others => 'X'); -- dq
			sdram_wire_dqm                                   : out   std_logic_vector(1 downto 0);                     -- dqm
			sdram_wire_ras_n                                 : out   std_logic;                                        -- ras_n
			sdram_wire_we_n                                  : out   std_logic;                                        -- we_n
			switch_external_connection_export                : in    std_logic_vector(9 downto 0)  := (others => 'X'); -- export
			touch_panel_busy_external_connection_export      : in    std_logic                     := 'X';             -- export
			touch_panel_pen_irq_n_external_connection_export : in    std_logic                     := 'X';             -- export
			touch_panel_spi_external_MISO                    : in    std_logic                     := 'X';             -- MISO
			touch_panel_spi_external_MOSI                    : out   std_logic;                                        -- MOSI
			touch_panel_spi_external_SCLK                    : out   std_logic;                                        -- SCLK
			touch_panel_spi_external_SS_n                    : out   std_logic                                         -- SS_n
		);
	end component Video_Qsys;

	u0 : component Video_Qsys
		port map (
			alt_vip_cl_cvo_0_clocked_video_vid_clk           => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_clk,           --            alt_vip_cl_cvo_0_clocked_video.vid_clk
			alt_vip_cl_cvo_0_clocked_video_vid_data          => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_data,          --                                          .vid_data
			alt_vip_cl_cvo_0_clocked_video_underflow         => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_underflow,         --                                          .underflow
			alt_vip_cl_cvo_0_clocked_video_vid_datavalid     => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_datavalid,     --                                          .vid_datavalid
			alt_vip_cl_cvo_0_clocked_video_vid_v_sync        => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_v_sync,        --                                          .vid_v_sync
			alt_vip_cl_cvo_0_clocked_video_vid_h_sync        => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_h_sync,        --                                          .vid_h_sync
			alt_vip_cl_cvo_0_clocked_video_vid_f             => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_f,             --                                          .vid_f
			alt_vip_cl_cvo_0_clocked_video_vid_h             => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_h,             --                                          .vid_h
			alt_vip_cl_cvo_0_clocked_video_vid_v             => CONNECTED_TO_alt_vip_cl_cvo_0_clocked_video_vid_v,             --                                          .vid_v
			clk_clk                                          => CONNECTED_TO_clk_clk,                                          --                                       clk.clk
			clk_sdram_clk                                    => CONNECTED_TO_clk_sdram_clk,                                    --                                 clk_sdram.clk
			clk_spi_clk                                      => CONNECTED_TO_clk_spi_clk,                                      --                                   clk_spi.clk
			clk_vga_clk                                      => CONNECTED_TO_clk_vga_clk,                                      --                                   clk_vga.clk
			lapton_conduit_end_mem_read_addr                 => CONNECTED_TO_lapton_conduit_end_mem_read_addr,                 --                        lapton_conduit_end.mem_read_addr
			lapton_conduit_end_mem_read_clk                  => CONNECTED_TO_lapton_conduit_end_mem_read_clk,                  --                                          .mem_read_clk
			lapton_conduit_end_i2c_scl                       => CONNECTED_TO_lapton_conduit_end_i2c_scl,                       --                                          .i2c_scl
			lapton_conduit_end_i2c_sda                       => CONNECTED_TO_lapton_conduit_end_i2c_sda,                       --                                          .i2c_sda
			lapton_conduit_end_spi_cs_n                      => CONNECTED_TO_lapton_conduit_end_spi_cs_n,                      --                                          .spi_cs_n
			lapton_conduit_end_spi_mosi                      => CONNECTED_TO_lapton_conduit_end_spi_mosi,                      --                                          .spi_mosi
			lapton_conduit_end_spi_miso                      => CONNECTED_TO_lapton_conduit_end_spi_miso,                      --                                          .spi_miso
			lapton_conduit_end_spi_clk                       => CONNECTED_TO_lapton_conduit_end_spi_clk,                       --                                          .spi_clk
			lapton_conduit_end_mem_read_data                 => CONNECTED_TO_lapton_conduit_end_mem_read_data,                 --                                          .mem_read_data
			lapton_reset_n_external_connection_export        => CONNECTED_TO_lapton_reset_n_external_connection_export,        --        lapton_reset_n_external_connection.export
			lcd_cs_n_export                                  => CONNECTED_TO_lcd_cs_n_export,                                  --                                  lcd_cs_n.export
			lcd_data_export                                  => CONNECTED_TO_lcd_data_export,                                  --                                  lcd_data.export
			lcd_rd_n_export                                  => CONNECTED_TO_lcd_rd_n_export,                                  --                                  lcd_rd_n.export
			lcd_reset_n_export                               => CONNECTED_TO_lcd_reset_n_export,                               --                               lcd_reset_n.export
			lcd_rs_export                                    => CONNECTED_TO_lcd_rs_export,                                    --                                    lcd_rs.export
			lcd_wr_n_export                                  => CONNECTED_TO_lcd_wr_n_export,                                  --                                  lcd_wr_n.export
			led_external_connection_export                   => CONNECTED_TO_led_external_connection_export,                   --                   led_external_connection.export
			reset_reset_n                                    => CONNECTED_TO_reset_reset_n,                                    --                                     reset.reset_n
			sdram_wire_addr                                  => CONNECTED_TO_sdram_wire_addr,                                  --                                sdram_wire.addr
			sdram_wire_ba                                    => CONNECTED_TO_sdram_wire_ba,                                    --                                          .ba
			sdram_wire_cas_n                                 => CONNECTED_TO_sdram_wire_cas_n,                                 --                                          .cas_n
			sdram_wire_cke                                   => CONNECTED_TO_sdram_wire_cke,                                   --                                          .cke
			sdram_wire_cs_n                                  => CONNECTED_TO_sdram_wire_cs_n,                                  --                                          .cs_n
			sdram_wire_dq                                    => CONNECTED_TO_sdram_wire_dq,                                    --                                          .dq
			sdram_wire_dqm                                   => CONNECTED_TO_sdram_wire_dqm,                                   --                                          .dqm
			sdram_wire_ras_n                                 => CONNECTED_TO_sdram_wire_ras_n,                                 --                                          .ras_n
			sdram_wire_we_n                                  => CONNECTED_TO_sdram_wire_we_n,                                  --                                          .we_n
			switch_external_connection_export                => CONNECTED_TO_switch_external_connection_export,                --                switch_external_connection.export
			touch_panel_busy_external_connection_export      => CONNECTED_TO_touch_panel_busy_external_connection_export,      --      touch_panel_busy_external_connection.export
			touch_panel_pen_irq_n_external_connection_export => CONNECTED_TO_touch_panel_pen_irq_n_external_connection_export, -- touch_panel_pen_irq_n_external_connection.export
			touch_panel_spi_external_MISO                    => CONNECTED_TO_touch_panel_spi_external_MISO,                    --                  touch_panel_spi_external.MISO
			touch_panel_spi_external_MOSI                    => CONNECTED_TO_touch_panel_spi_external_MOSI,                    --                                          .MOSI
			touch_panel_spi_external_SCLK                    => CONNECTED_TO_touch_panel_spi_external_SCLK,                    --                                          .SCLK
			touch_panel_spi_external_SS_n                    => CONNECTED_TO_touch_panel_spi_external_SS_n                     --                                          .SS_n
		);

